; Professional Music Driver P.M.D. (for PMDPPZ)
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

start:		cli
		mov	ax,cs
		mov	ds,ax
		mov	es,ax

		mov	ah,0x0b		; Ff[^̈ʒu擾(DS:DX)
		int	0x60
		mov	cx,0xffff
		mov	bx,0x05		; ʉf[^pnh
		mov	ah,0x3f
		int	0x21		; Ff[^[h

		mov	ax,cs
		mov	ds,ax

		mov	ax,0x257e	; hoothCoo^
		mov	dx,vect_7e
		int	0x21

		sti
mainloop:	mov	ax,0x9801	; _~[|[O
		int	0x18
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7e:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .fadeout
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		mov	ah,0x01		; t~
		int	0x60
		mov	ah,0x12		; [PPZ8] PCMݒ~
		int	0x7f

		mov	ah,0x06		; ȃf[^obt@AhX擾(DS:DX)
		int	0x60
		xor	bx,bx		; W
		mov	cx,0xffff	; f[^TCY
		mov	ah,0x3f		; [DOS] read hundle
		int	0x21
		jc	.stop

		mov	ax,0x1dfe	; #PPZFile擾 (DS:DX)
		int	0x60

		call	checkpvi	; PVI
		jc	.playexec	; wȂ͉̎tJn

		mov	ax,0x0301	; [PPZ8] ϐQƂȂŃ[h
		xor	cl,cl
		int	0x7f		; [PPZ8] PVI/PZI[hs(oN0)
		jc	.pviloaderr

		cmp	dx,si		; PVI2邩?
		jz	.playexec
		mov	dx,si
		call	checkpvi	; 2߂PCM[h
		jc	.pviloaderr

		mov	ax,0x0301	; [PPZ8] ϐQƂȂŃ[h
		mov	cl,1
		int	0x7f		; [PPZ8] PVI/PZI[hs(oN1)
		jc	.pviloaderr

.playexec:	xor	ah,ah		; tJn
		int	0x60
		jmp	short .ed

.stop:		mov	ah,1		; t~
		int	0x60
		jmp	short .ed

.fadeout:	mov	ax,0x0208	; tF[hAEg
		int	0x60
		jmp	short .ed

.pviloaderr:	mov	ax,cs
		mov	ds,ax
		mov	dx,pvierr
		mov	ah,0x09		; PVIȂ|̃G[bZ[W\
		int	0x21
		jmp	short .ed

; PVI/PZIt@C̃`FbN(DS:DX)
checkpvi:	mov	si,dx
.checkloop:	lodsb
		or	al,al
		jz	.notfound
		cmp	al,'.'		; sIhT
		jnz	.checkloop
		mov	al,[si+1]	; PVI/PZIp
		cmp	byte [si+3],','	; PVIw肪? ".pzi,"
		jnz	.nopvi2
		mov	byte [si+3],0x00	; ꍇ̓t@C̏I[Zbg
		add	si,4		; oN1ƂSIɃoN2̃t@C̈ʒuԂ
		jmp	short .extcheck

.nopvi2:	mov	si,dx		; oN2ȂƂDX=SIŕԂ
.extcheck:	or	al,0x20		; ɐK
		cmp	al,'v'		; 蔲
		jz	.foundpvi
		cmp	al,'z'
		jz	.foundpzi
.notfound:	stc			; Ȃ
		ret

.foundpvi:	xor	ch,ch		; PVIł
		ret

.foundpzi:	mov	ch,1		; PZIł
		clc
		ret

pvierr:		db	'PVI/PZI܂.',0x0d,0x0a,'$'

		ends

